<template>
    <q-skeleton class="fit" type="rect" v-if="index === -1 || widget == null"/>
    <FloorChart v-else-if="index === 0" :days="widgetConstructor.days"
                :options="widgetConstructor.options" :settings="widgetConstructor.settings"/>
    <WorkerChart v-else-if="index === 1" :days="widgetConstructor.days" :floor="widgetConstructor.floor"
                 :settings="widgetConstructor.settings" :options="widgetConstructor.option"/>
    <CompareMetricWidget v-else-if="index === 2" :left-value="widgetConstructor.leftValue" :right-value="widgetConstructor.rightValue"
                         :left="widgetConstructor.left" :right="widgetConstructor.right" :title="widgetConstructor.title"/>
    <RelativeMetricWidget v-else-if="index === 3" :value="widgetConstructor.value" :prev="widgetConstructor.prev"
                          :overline="widgetConstructor.overline" :unit="widgetConstructor.unit"/>
    <SingleValueWidget v-else-if="index === 4" :overline="widgetConstructor.overline" :value="widgetConstructor.value" :unit="widgetConstructor.unit"/>
    <div v-else>
        Something went wrong :/
    </div>
</template>

<script lang='ts'>
import {Component, Prop, Vue, Watch} from 'vue-property-decorator';
import {ChartWidget, TextWidget, Widget, WidgetData} from "src/classLibrary/Dashboard/Dashboard";
import {FloorChartParser, FloorChartWidget} from "src/classLibrary/Dashboard/FloorChartWidget";
import {WorkerChartParser, WorkerChartWidget} from "src/classLibrary/Dashboard/WorkerChartWidget";
import {SingleValueTextWidget, SingleValueWidgetParser} from "src/classLibrary/Dashboard/SingleValueTextWidget";
import {RelativeTextParser, RelativeTextWidget} from "src/classLibrary/Dashboard/RelativeTextWidget";
import {CompareTextWidget, CompareWidgetParser} from "src/classLibrary/Dashboard/CompareWidget";
import {SingleMetricQuerier} from "src/classLibrary/Dashboard/SingeMetricQuery";
import {Result} from "@hqoss/monads";
import {ApiError} from "src/classLibrary/Core/Api";
import {WarnMessage} from "src/classLibrary/Utility";
import WorkerChart from "components/Charts/WorkerChart.vue";
import FloorChart from "components/Charts/FloorChart.vue";
import CompareMetricWidget from "components/Widget/CompareMetricWidget.vue";
import RelativeMetricWidget from "components/Widget/RelativeMetricWidget.vue";
import SingleValueWidget from "components/Widget/SingleValueWidget.vue";

@Component({
    components: {SingleValueWidget, RelativeMetricWidget, CompareMetricWidget, FloorChart, WorkerChart}
})
export default class WidgetRenderer extends Vue {

    @Prop() widget!: Widget;

    index: number = -1;
    widgetConstructor: any = {};

    @Watch('widget', {deep: true})
    async OnWidgetChange() {
        if (this.widget == null) return;
        const data = this.widget.widget;

        const pid = this.PersistentStore.StoreValue.project;
        const metricClient = new SingleMetricQuerier(this.$analyticsApi, this.$auth, pid);

        const floorChartParser = new FloorChartParser(this.$analyticsApi, this.$auth, pid);
        const workerChartParser = new WorkerChartParser(this.$coreApi, this.$analyticsApi, this.$auth, pid);

        const compareParser = new CompareWidgetParser(metricClient);
        const relativeParser = new RelativeTextParser(metricClient);
        const singleParser = new SingleValueWidgetParser(metricClient);

        const r = await WidgetData.match<Promise<Result<[any, number], ApiError>>>(data, {
            Chart(chart: ChartWidget) {
                return ChartWidget.match<Promise<Result<[any, number], ApiError>>>(chart, {
                    async Floor(p0: FloorChartWidget) {
                        const r = await floorChartParser.LoadSettings(p0, new Date());
                        return r.map(v => [v, 0]);
                    },
                    async Worker(p0: WorkerChartWidget) {
                        const r = await workerChartParser.LoadSettings(p0, new Date());
                        return r.map(v => [v, 1]);
                    }
                });
            },
            Text(text: TextWidget) {
                return TextWidget.match<Promise<Result<[any, number], ApiError>>>(text, {
                    async Compare(p0: CompareTextWidget) {
                        const r = await compareParser.LoadSetting(p0);
                        return r.map(e => [e, 2])
                    },
                    async Relative(p0: RelativeTextWidget) {
                        const r = await relativeParser.LoadSettings(p0);
                        return r.map(e => [e, 3])
                    },
                    async Single(p0: SingleValueTextWidget) {
                        const r = await singleParser.LoadSettings(p0);
                        return r.map(e => [e, 4])
                    }
                });
            }

        });

        if (r.isErr()) {
            console.error(r.unwrapErr())
            this.$q.notify(WarnMessage('Failed to query'));
            return;
        }
        const [c, index] = r.unwrap();
        this.widgetConstructor = c;
        this.index = index;
    }


}
</script>

<style lang='scss' scoped>

</style>
